;------------------------------------------------------------------------
;Zahlenraten v2.4 von Mr.Smile
;This is my first "good" Fargo program
;Tuesday, the 9th of march 1999
;------------------------------------------------------------------------
       include "flib.h"
       include "tios.h"
       include macros.h
       include macros2.h
       xdef _main
       xdef _comment
_main:
startbildschirm:
       jsr flib::zap_screen
       SetFont #2
       WriteStr  #10,#10,#1,start1
       WriteStr #10,#30,#1,start2      
       jsr flib::idle_loop    ;wartet auf taste
ganz_vorne:
       clr.w d6                 ;Punkte = 0
neues_spiel:
       clr.w d4                 ;untere Grenze = 0
       move.w #999,d5           ;obere Grenze = 999
       move.w #1,vers           ;Versuch = 1
zufallszahl:
       move.w #1000,d0 ;0-1000
       jsr flib::random
       move.w d0,d7 ;zufzahl....Zufallszahl 
spieloberflaeche:
       jsr flib::zap_screen
       SetFont #0
       WriteStr #100,#122,#1,text0 ;APPS
       WriteStr #165,#122,#1,text1 ;ESC
       WriteStr #40,#122,#1,text15 ;CLEAR
       bsr lines
       WriteStr #13,#1,#1,text2 ;Version X.X von ....
       SetFont #2
       WriteStr #10,#30,#1,text3 ;Raten von Zahlen
       bsr u_grenze
       bsr o_grenze
       WriteStr #10,#75,#1,text6 ;Dein Tip
       bsr punkte
       bsr versuche
Eingabe:
       clr.w z0 ;Position 3 = 0
       clr.w z1 ;Position 2 = 0
       clr.w z2 ;Position 1 = 0
       move.w #1,d3 ;Zhler = 1
schleife:
       move.w vers,a
       add.w #48,a
       jsr flib::idle_loop     ;Wartet auf Tastendruck
       cmp.w #13,d0            ;wenn Taste=ENTER -> GOTO FERTIG
       beq fertig
       cmp.w #263,d0           ;wenn Taste=CLEAR -> GOTO RESET
       beq reset
       cmp.w #257,d0           ;wenn Taste=DEL -> GOTO LSCHEN
       beq lschen
       cmp.w #264,d0           ;wenn Taste=ESC -> GOTO ENDE
       beq ende       
       cmp.w #265,d0           ;wenn Taste=APPS -> GOTO AUSSCHALTEN
       beq ausschalten
       cmp.w #48,d0            ;wenn Taste keine Zahl ist -> beginne von vorne
       blt schleife 
       cmp.w #57,d0            ;wenn Taste keine Zahl ist -> beginne von vorne
       bgt schleife       
       move.w d0,z0
       cmp.w #1,d3             ;wenn Zhler = 1 => Taste = d2
       beq zhler_1
       cmp.w #2,d3             ;wenn Zhler = 2 => Taste = d1
       beq zhler_2
zurck_1:
       cmp.w #4,d3             ;wenn Zhler = 4 => Zhler = 3
       beq zhler_gr
       cmp.w #0,d3             ;wenn Zhler = 0 => Zhler = 1
       beq zhler_kl
zurck_2:
       mulu.w #8,d3
       move.w d3,xpos
       divu.w #8,d3
       add.w #80,xpos           ;berechnet Cursorposition 
       WriteChar xpos,#75,#1,z0 ;Schreibt Zahl
       add.w #1,d3              ;Zhler + 1 = Zhler
       bra schleife             ;GOTO schleife
fertig: 
       box #88,#75,#111,#83 ;Lscht Eingabefeld
       move.w z0,d0
       move.w z1,d1
       move.w z2,d2
       cmp.w #3,d3
       beq zwei_st
       cmp.w #4,d3
       beq drei_st
       bsr umrech
vergleich:
; z2 = eingegebene Zahl
; d7 = Zufallszahl
       cmp.w z2,d7 ;wenn Zufallszahl = eingegebene Zahl => GOTO erraten
       beq erraten
       move.w vers,d0
       add.w #1,d0
       move.w d0,vers
       cmp.w z2,d7 ;wenn eingegebene Zahl > Zufallszahl => GOTO unt_gre1 
       bgt unt_gre1
       cmp.w z2,d5 ;wenn eingegebene Zahl < obere Grenze => GOTO ob_gre2
       bgt ob_gre2          
       bra spieloberflaeche    
ob_gre2
       move.w z2,d5 ;definiert d2 als obere Grenze
       bra spieloberflaeche
unt_gre1:
       cmp.w z2,d4 ;wenn eingegebene Zahl > untere Grenze => GOTO unt_gre2 
       blt unt_gre2
       bra spieloberflaeche
unt_gre2:       
       move.w z2,d4 ;definiert d2 als untere Grenze
       bra spieloberflaeche
erraten:
       jsr flib::zap_screen
       bsr lines
       SetFont #0
       WriteStr #13,#1,#1,text2 
       WriteStr #95,#122,#1,text8
       SetFont #2
       WriteStr #10,#40,#1,text11
       WriteStr #44,#55,#1,text12
       move.w vers,d1
       mulu.w #5,d1
       move.w #100,d0
       sub.w d1,d0 ;d0 ... erreichte Punkte
       cmp.w #0,d0 ;wenn erreichte Punkte <0 => GOTO error_0
       blt error_0
zuruck1:
       add.w d0,d6 ;Gesamtpunkte
       cmp.w #999,d6
       bgt error_999
zuruck2:
       move.w #10,xco
       move.w #55,yco
       bsr zahlenausgabe
       jsr flib::idle_loop
       bra neues_spiel
error_999:
       move.w #999,d6
       bra zuruck2
error_0:
       move.w #0,d0
       bra zuruck1
umrech:
       sub.w #48,z0
       sub.w #48,z1
       sub.w #48,z2
       move.w z0,d0
       move.w z1,d1
       move.w z2,d2
       rts
zwei_st:
       bsr umrech
       mulu.w #10,d2
       add.w d1,d2
       move.w d2,z2
       bra vergleich
drei_st:
       bsr umrech
       mulu.w #100,d2
       mulu.w #10,d1
       add.w d1,d2
       add.w d0,d2
       move.w d2,z2
       bra vergleich
lschen:
       cmp.w #1,d3
       beq schleife
       sub.w #1,d3
       cmp.w #3,d3
       beq del_3
       cmp.w #2,d3
       beq del_2
       cmp.w #1,d3
       beq del_1
lines:
       move.l   #30,-(a7)          ;Lnge der Linie 240 Bytes = 240 Pxl 
       move.w   #$FFFF,-(a7) 
       move.l   #LCD_MEM+210,-(a7) ;Anfangspunkt: 270 bytes / 30 bytes = 9 Pxl 
       jsr      tios::memset       ;Zeichnet Linie
       lea      10(a7),a7          ;Korrigiert Stack
       move.l   #30,-(a7)          ;Lnge der Linie 240 Bytes = 240 Pxl 
       move.w   #$FFFF,-(a7) 
       move.l   #LCD_MEM+3600,-(a7) ;Anfangspunkt: 270 bytes / 30 bytes = 9 Pxl 
       jsr      tios::memset       ;Zeichnet Linie
       lea      10(a7),a7          ;Korrigiert Stack
       rts
del_1:
       box #88,#75,#95,#83
       bra schleife
del_2:
       box #96,#75,#103,#83
       bra schleife
del_3: 
       box #104,#75,#111,#83
       bra schleife
zhler_1:
       move.w z0,z2
       bra zurck_1
zhler_2:
       move.w z0,z1
       bra zurck_1
zhler_gr:
       box #104,#75,#111,#83 ;Lscht Feld
       move.w #3,d3
       bra zurck_2
zhler_kl:
       move.w #1,d3
       bra zurck_2
ausschalten:
       trap #4 
       beq schleife
o_grenze:
       WriteStr #10,#60,#1,text5 ;obere Grenze
       move.w d5,d0
       move.w #112,xco
       move.w #60,yco
       bsr zahlenausgabe
       rts
u_grenze:
       WriteStr #10,#45,#1,text4 ;untere Grenze
       move.w d4,d0
       move.w #112,xco
       move.w #45,yco
       bsr zahlenausgabe
       rts
reset:
       bsr ende
       trap #2
       rts
punkte:
       WriteStr #10,#90,#1,text7 ;Punkte
       move.w d6,d0
       move.w #73,xco
       move.w #90,yco
       bsr zahlenausgabe
       rts
versuche:
       WriteStr #125,#90,#1,text10 ;Versuche
       move.w vers,d0
       move.w #180,xco
       move.w #90,yco
       bsr zahlenausgabe
       rts
zahlenausgabe:
;Input: Zahl = d0
;Input: x-Position = xco
;Input: y-Position = yco
	moveq   #3,d1 ;Anzahl der Stellen
	lea     tstr(PC),a0
	bsr ConvStr
	WriteStr xco,yco,#1,tstr
       rts
ConvStr:
       adda.l  d1,a0
       clr.b   (a0)
       subq.b  #1,d1
RepConv:
      divu    #10,d0
      move.l  d0,d2
      lsr.l   #8,d2
      lsr.l   #8,d2
      add.b   #48,d2
      move.b  d2,-(a0)
      and.l   #$FFFF,d0
      dbra    d1,RepConv
      rts
ende:
       jsr flib::zap_screen
       WriteStr #17,#60,#1,text9
       jsr flib::idle_loop
       rts
start1       dc.b "Start game by pressing",0
start2       dc.b "any button!!!!",0    
text0        dc.b "APPS = BYE",0
text1        dc.b "ESC = QUIT",0
text2        dc.b "Version 2.4 by for Fargo II by Mr.Smile(9. March 1999)",0
text3        dc.b "Advise the right number!",0
text4        dc.b "Lower limit:",0
text5        dc.b "Upper limit:",0
text6        dc.b "Your tip:",0
text7        dc.b "Points:",0
text8        dc.b "Press any key!",0
text9        dc.b "Bye, Bye! Have a nice day",0
text10       dc.b "Tries:",0
text11       dc.b "You have done it. You get",0
text12       dc.b "of 100 points",0
text15       dc.b "CLEAR = ???",0
xpos         dc.w 0 ;definiert Variable xpos
vers         dc.w 0 ;definiert Variable vers
z1           dc.w 0 ;definiert Variable z1
z2           dc.w 0 ;definiert Variable z2
z0           dc.w 0 ;definiert Variable z0
a            dc.w 0 ;definiert Variable a
xco          dc.w 0 ;definiert Variable xco
yco          dc.w 0 ;definiert Variable yco
tstr         dc.w 0 ;definiert Variable tstr
_comment     dc.b "Advising numbers v2.4 fr Fargo 2",0
       end